searchData={"items":[{"type":"module","title":"grisp_update_packager","doc":null,"ref":"grisp_update_packager.html"},{"type":"function","title":"grisp_update_packager.package/2","doc":"Creates a GRiSP software update package. The output path is either a directory where all the package files will be stored, or a tarball file name that will contain all the package files. In both cases the directory or the file must not already exist. Options: tarball (optional boolean): If the package files should be stored in a tarball. if false the update manifest and files will be stored in the specified directory. Default: true . name (required binary): The product name that will be specified in the manifest. version (required binary): The product version that will be specified in the manifest. description (optional binary): The product description that will be specified in the manifest. architecture (optional binary): The target architecture of the update package. Default: arm-grisp2-rtems . manifest (optional term): An optional software manifest describing the software being packaged. block_size (optional positive integer): The size in bytes of the update chunks before compression. Default: 4194304 . key_file (optional binary): The path to a PEM file containing the signing key to use to seal the manifest. Only one of key_file and key option can be specified at the same time. key (optional private key record): A decoded private key to use to seal the manifest. Only one of key_file and key option can be specified at the same time. system (optional binary): The uncompressed system firmware image to be written on the update system partition. It is optional, so it is possible to create a bootloader-only update package. bootloader (optional binary): The uncompressed bootloader firmware image to be included in the software update package. If not specified, the package will not contain the bootloader. files (optional list): A list of extra files to be installed during software update. The files will not be chuncked and will be included as a single compressed block. If a URL is specified, the file will not be included in the update package, instead it will be expected to be available at the given external URL, the file is still required locally though, as it is needed to compute the hashes. The format of the file specification is a map with the following fields: name (required binary): The name of the system file as it will appear in the manifest. local (required binary): The path to the local file to be included. target (required binary): The path in the target filesystem where the file will be installed. url (optional binary): The URL the data should be retrieved from instead of including the file in the update package. mbr (optional list): Either the option mbr or gpt is required. Specify the MBR partition table of the target filesystem. It is a list of at most 4 MBR partition specifications as maps with the following fields: role (required atom): The role of the partition, could be boot , system or data . The firmware can only be written to a system partition. type (optional atom): The type of the partition, can be fat , fat32 or dos , all equivalent, fat being the default and dos being deprecated. start (optional positive integer): The start position of the partition in bytes. Must be a multiple of the sector size (512). If not specified, it will be the end of the previous partition or 0 . size (required positive integer): The size of the partition in bytes. Must be a multiple of the sector size (512). gpt (optional list): Either the option mbr or gpt is required. Specify GPT partition table of the target file-system. It is a list of GPT partition specifications as maps with the following fields: role (required atom): The role of the partition, could be boot , system or data . The firmware can only be written to a system partition. type (optional atom or binary): The type of the partition, can be one of the atoms linux , swap , home , efi , raid , llvm or bdp for standard GPT partition types or a binary UUID. id (required binary): The binary UUID identifier of the partition. start (optional positive integer): The start position of the partition in bytes. Must be a multiple of the sector size (512). If not specified, it will be the end of the previous partition or 0 . size (required positive integer): The size of the partition in bytes. Must be a multiple of the sector size (512).","ref":"grisp_update_packager.html#package/2"},{"type":"type","title":"grisp_update_packager.gpt_partition/0","doc":null,"ref":"grisp_update_packager.html#t:gpt_partition/0"},{"type":"type","title":"grisp_update_packager.gpt_partition_table/0","doc":null,"ref":"grisp_update_packager.html#t:gpt_partition_table/0"},{"type":"type","title":"grisp_update_packager.mbr_partition/0","doc":null,"ref":"grisp_update_packager.html#t:mbr_partition/0"},{"type":"type","title":"grisp_update_packager.mbr_partition_table/0","doc":null,"ref":"grisp_update_packager.html#t:mbr_partition_table/0"},{"type":"type","title":"grisp_update_packager.package_options/0","doc":null,"ref":"grisp_update_packager.html#t:package_options/0"},{"type":"type","title":"grisp_update_packager.update_file/0","doc":null,"ref":"grisp_update_packager.html#t:update_file/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n## [1.0.1] - 2025-05-22","ref":"changelog.html"},{"type":"extras","title":"Changes - Changelog","doc":"- Include a software manifest in the update manifest if available\n\n## [1.0.0] - 2024-09-06\n\nFirst release.\n\n[Unreleased]: https://github.com/grisp/grisp_update_packager/compare/1.0.1...HEAD\n[1.0.1]: https://github.com/grisp/grisp_update_packager/compare/1.0.0...1.0.1\n[1.0.0]: https://github.com/grisp/grisp_update_packager/compare/753d621f36907e3d5676cc0bf0db43276f39c5a6...1.0.0","ref":"changelog.html#changes"},{"type":"extras","title":"Overview","doc":"# grisp_updater_packager\n\nGRiSP Software Update Packager","ref":"readme.html"},{"type":"extras","title":"Build - Overview","doc":"$ rebar3 copmile","ref":"readme.html#build"},{"type":"extras","title":"Usage - Overview","doc":"To create a software update package with system firmware and bootloader firmware\nfor a GRiSP 2 board with standard partition structure:\n\n    grisp_update_packager:package(<<\"package.tar\">>, #{\n        name := ReleaseName,\n        version := ReleaseVersion,\n        firmware => SystemFirmwarePath,\n        bootloader => BootloaderFirmwarePath,\n        mbr => [\n            #{role => system, size => 268435456, start => 4194304},\n            #{role => system, size => 268435456}\n        ]\n    }).\n\nTo generate a signed package, add the option `key_file` with the path to a PEM\nencoded private key (not encrypted), or `key` with a decoded private key record.\n\nNote that the firmwares must be raw uncompressed files.","ref":"readme.html#usage"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright 2024, Peer Stritzinger GmbH  .\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}